<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerRiskScoreDwData ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerRiskScoreDwData extends AbstractStructArrayBase
{
    /**
     * The CustomerRiskScoreDwData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\CustomerRiskScoreDwData[]
     */
    public $CustomerRiskScoreDwData;
    /**
     * Constructor method for ArrayOfCustomerRiskScoreDwData
     * @uses ArrayOfCustomerRiskScoreDwData::setCustomerRiskScoreDwData()
     * @param \CustomerManagement\StructType\CustomerRiskScoreDwData[] $customerRiskScoreDwData
     */
    public function __construct(array $customerRiskScoreDwData = array())
    {
        $this
            ->setCustomerRiskScoreDwData($customerRiskScoreDwData);
    }
    /**
     * Get CustomerRiskScoreDwData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData[]|null
     */
    public function getCustomerRiskScoreDwData()
    {
        return isset($this->CustomerRiskScoreDwData) ? $this->CustomerRiskScoreDwData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerRiskScoreDwData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerRiskScoreDwData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerRiskScoreDwDataForArrayConstraintsFromSetCustomerRiskScoreDwData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem instanceof \CustomerManagement\StructType\CustomerRiskScoreDwData) {
                $invalidValues[] = is_object($arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem) ? get_class($arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem) : sprintf('%s(%s)', gettype($arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem), var_export($arrayOfCustomerRiskScoreDwDataCustomerRiskScoreDwDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerRiskScoreDwData property can only contain items of type \CustomerManagement\StructType\CustomerRiskScoreDwData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerRiskScoreDwData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerRiskScoreDwData[] $customerRiskScoreDwData
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerRiskScoreDwData
     */
    public function setCustomerRiskScoreDwData(array $customerRiskScoreDwData = array())
    {
        // validation for constraint: array
        if ('' !== ($customerRiskScoreDwDataArrayErrorMessage = self::validateCustomerRiskScoreDwDataForArrayConstraintsFromSetCustomerRiskScoreDwData($customerRiskScoreDwData))) {
            throw new \InvalidArgumentException($customerRiskScoreDwDataArrayErrorMessage, __LINE__);
        }
        if (is_null($customerRiskScoreDwData) || (is_array($customerRiskScoreDwData) && empty($customerRiskScoreDwData))) {
            unset($this->CustomerRiskScoreDwData);
        } else {
            $this->CustomerRiskScoreDwData = $customerRiskScoreDwData;
        }
        return $this;
    }
    /**
     * Add item to CustomerRiskScoreDwData value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerRiskScoreDwData $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerRiskScoreDwData
     */
    public function addToCustomerRiskScoreDwData(\CustomerManagement\StructType\CustomerRiskScoreDwData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\CustomerRiskScoreDwData) {
            throw new \InvalidArgumentException(sprintf('The CustomerRiskScoreDwData property can only contain items of type \CustomerManagement\StructType\CustomerRiskScoreDwData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerRiskScoreDwData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\CustomerRiskScoreDwData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerRiskScoreDwData
     */
    public function getAttributeName()
    {
        return 'CustomerRiskScoreDwData';
    }
}
